// src/monad/option.ts
var Some = (value) => value;
var None = () => void 0;
var present = (value) => value !== void 0;
var empty = (value) => value === void 0;

// src/monad/either.ts
var Left = (value) => {
  return {
    tag: "left",
    left: value
  };
};
var Right = (value) => {
  return {
    tag: "right",
    right: value
  };
};
var isLeft = (value) => value.tag === "left";
var isRight = (value) => value.tag === "right";
var fold = (value, left, right) => {
  switch (value.tag) {
    case "left":
      return left(value.left);
    case "right":
      return right(value.right);
  }
};

// src/computation/lazy.ts
var Lazy = (callback) => callback;
var AsyncLazy = (callback) => callback;
var computed = (value) => typeof value !== "function";
var compute = (value) => computed(value) ? value : value();
export {
  AsyncLazy,
  Lazy,
  Left,
  None,
  Right,
  Some,
  compute,
  computed,
  empty,
  fold,
  isLeft,
  isRight,
  present
};
//# sourceMappingURL=index.mjs.map